Subject: Re: VLAN rx acceleration bypasses bridge

From: Stephen Hemminger <[email-masked]>
Date: Sat, 24 Oct 2009 11:11:52 -0700

On Thu, 15 Oct 2009 01:58:05 +0200
Maxime Bizon <[email-masked]> wrote:

> 
> Hi Patrick, Stephen & all,
> 
> 
> If I do:
> 
> # vconfig add eth0 100
> # brctl addbr br0
> # brctl addif br0 eth0
> 
> Then eth0.100 gets no more packet and br0.100 should be used instead to
> get tagged packets.
> 
> But, if vlan rx acceleration is enabled on eth0, then vlan 100 packets
> no longer go through bridge, and eth0.100 is to be used instead.
> 
> This is fixable, but I'm not sure which behavior is preferred ?
> 
> 
> In case we prefer the first one, how could someone bridge untagged
> packets from eth0 with some tagged packets from eth1, and some tagged
> packets from eth0 with untagged packets from eth1 ?
> 
> Something like this, which currently works when vlan rx accel is on:
> 
> # vconfig add eth0 100
> # vconfig add eth1 100
> # brctl addbr br0
> # brctl addif br0 eth0
> # brctl addif br0 eth1.100
> # brctl addbr br1
> # brctl addif br1 eth0.100
> # brctl addif br1 eth1
> 
> 
> Regards,
> 

The way I see it, if you define a vlan then you need to bridge that
vlan. Mixing plain and vlanned interfaces is a mess that is hard to untangle
and probably not worth fixing.